import { __assign, __spread, __decorate, __param } from 'tslib';
import { Optional, Injectable, NgModule } from '@angular/core';

var _a;
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel["INFO"] = 0] = "INFO";
    LogLevel[LogLevel["DEBUG"] = 1] = "DEBUG";
    LogLevel[LogLevel["WARNING"] = 2] = "WARNING";
    LogLevel[LogLevel["ERROR"] = 3] = "ERROR";
})(LogLevel || (LogLevel = {}));
var AbstractNgxFancyLoggerService = /** @class */ (function () {
    function AbstractNgxFancyLoggerService() {
    }
    return AbstractNgxFancyLoggerService;
}());
var LoggerConfig = /** @class */ (function () {
    function LoggerConfig() {
        this.showTime = true;
        this.logLevel = LogLevel.INFO;
        this.levelColor = {};
    }
    return LoggerConfig;
}());
var DEFAULT_LEVEL_COLORS = (_a = {},
    _a[LogLevel.INFO] = 'steelblue',
    _a[LogLevel.DEBUG] = 'black',
    _a[LogLevel.WARNING] = 'orange',
    _a[LogLevel.ERROR] = 'red',
    _a);
var NgxFancyLoggerService = /** @class */ (function () {
    function NgxFancyLoggerService(loggerConfig) {
        var _this = this;
        this.loggerConfig = loggerConfig;
        this.DEFAULT_CONFIG = new LoggerConfig();
        this.showTime = function () {
            return _this.config.showTime ? " > " + new Date().toLocaleString() : '';
        };
        this.getStyles = function (level) { return "color:white;\n                                            background-color:" + (_this.config.levelColor[level] || DEFAULT_LEVEL_COLORS[level]) + ";\n                                            padding: 0px 2px;\n                                            border-radius: 2px"; };
        this.config = __assign(__assign({}, this.DEFAULT_CONFIG), loggerConfig);
    }
    NgxFancyLoggerService.prototype.info = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.log(LogLevel.INFO, 'log', args);
    };
    NgxFancyLoggerService.prototype.debug = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.log(LogLevel.DEBUG, 'log', args);
    };
    NgxFancyLoggerService.prototype.warning = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.log(LogLevel.WARNING, 'warn', args);
    };
    NgxFancyLoggerService.prototype.error = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.log(LogLevel.ERROR, 'error', args);
    };
    NgxFancyLoggerService.prototype.log = function (level, method) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        if (level < this.config.logLevel) {
            return;
        }
        console[method].apply(console, __spread(["%c" + LogLevel[level] + this.showTime(), this.getStyles(level)], args));
    };
    NgxFancyLoggerService.ctorParameters = function () { return [
        { type: LoggerConfig, decorators: [{ type: Optional }] }
    ]; };
    NgxFancyLoggerService = __decorate([
        Injectable(),
        __param(0, Optional())
    ], NgxFancyLoggerService);
    return NgxFancyLoggerService;
}());

var NgxFancyLoggerModule = /** @class */ (function () {
    function NgxFancyLoggerModule() {
    }
    NgxFancyLoggerModule_1 = NgxFancyLoggerModule;
    NgxFancyLoggerModule.forRoot = function (config) {
        return {
            ngModule: NgxFancyLoggerModule_1,
            providers: [
                { provide: LoggerConfig, useValue: config || {} },
                NgxFancyLoggerService
            ]
        };
    };
    var NgxFancyLoggerModule_1;
    NgxFancyLoggerModule = NgxFancyLoggerModule_1 = __decorate([
        NgModule({
            imports: [],
            providers: [NgxFancyLoggerService]
        })
    ], NgxFancyLoggerModule);
    return NgxFancyLoggerModule;
}());

/*
 * Public API Surface of ngx-fancy-logger
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AbstractNgxFancyLoggerService, LogLevel, LoggerConfig, NgxFancyLoggerModule, NgxFancyLoggerService };
//# sourceMappingURL=ngx-fancy-logger.js.map
