export declare enum LogLevel {
    INFO = 0,
    DEBUG = 1,
    WARNING = 2,
    ERROR = 3
}
export declare abstract class AbstractNgxFancyLoggerService {
    abstract info(...args: any[]): void;
    abstract debug(...args: any[]): void;
    abstract warning(...args: any[]): void;
    abstract error(...args: any[]): void;
}
export declare class LoggerConfig {
    showTime?: boolean;
    logLevel?: LogLevel;
    levelColor?: {
        [logLevel: number]: string;
    };
}
export declare class NgxFancyLoggerService implements AbstractNgxFancyLoggerService {
    private loggerConfig;
    config: LoggerConfig;
    DEFAULT_CONFIG: LoggerConfig;
    constructor(loggerConfig: LoggerConfig);
    private showTime;
    private getStyles;
    info(...args: any[]): void;
    debug(...args: any[]): void;
    warning(...args: any[]): void;
    error(...args: any[]): void;
    private log;
}
